



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java多线程系列--“JUC线程池”06之 Callable和Future</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java多线程系列--“JUC线程池”06之 Callable和Future</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 11:30:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><strong>概要</strong></h3>
<p>本章介绍线程池中的Callable和Future。<br /><a href="#a1" rel="external nofollow noreferrer">Callable 和 Future 简介</a><br /><a href="#a2" rel="external nofollow noreferrer">示例和源码分析(基于JDK1.7.0_40)</a></p>
<p>转载请注明出处：<a href="http://www.cnblogs.com/skywang12345/p/3544116.html" rel="external nofollow noreferrer">http://www.cnblogs.com/skywang12345/p/3544116.html</a></p>
<h3><strong>Callable 和 Future 简介</strong></h3>
<p>　　Callable 和 Future 是比较有趣的一对组合。当我们需要获取线程的执行结果时，就需要用到它们。Callable用于产生结果，Future用于获取结果。</p>
<p><strong>1. Callable</strong></p>
<p>Callable 是一个接口，它只包含一个call()方法。Callable是一个返回结果并且可能抛出异常的任务。</p>
<p>为了便于理解，我们可以将Callable比作一个Runnable接口，而Callable的call()方法则类似于Runnable的run()方法。</p>
<p>Callable的源码如下：</p>
<div>
<pre class="prettyprint linenums">public interface Callable&lt;V&gt; {<br />
    V call() throws Exception;<br />
}</pre>
</div>
<p><strong>说明</strong>：从中我们可以看出Callable支持泛型。</p>
<p><strong>2. Future</strong></p>
<p>Future 是一个接口。它用于表示异步计算的结果。提供了检查计算是否完成的方法，以等待计算的完成，并获取计算的结果。</p>
<p>Future的源码如下：</p>
<div>
<pre class="prettyprint linenums">public interface Future&lt;V&gt; {<br />
    // 试图取消对此任务的执行。<br />
    boolean     cancel(boolean mayInterruptIfRunning)

    // 如果在任务正常完成前将其取消，则返回 true。<br />
    boolean     isCancelled()

    // 如果任务已完成，则返回 true。<br />
    boolean     isDone()

    // 如有必要，等待计算完成，然后获取其结果。<br />
    V           get() throws InterruptedException, ExecutionException;

    // 如有必要，最多等待为使计算完成所给定的时间之后，获取其结果（如果结果可用）。<br />
    V             get(long timeout, TimeUnit unit)<br />
          throws InterruptedException, ExecutionException, TimeoutException;<br />
}</pre>
</div>
<p><strong>说明</strong>： Future用于表示异步计算的结果。它的实现类是FutureTask，在讲解FutureTask之前，我们先看看Callable, Future, FutureTask它们之间的关系图，如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/497634/201402/111156106192237.jpg" /></p>
<p><strong>说明</strong>：<br />(01) RunnableFuture是一个接口，它继承了Runnable和Future这两个接口。RunnableFuture的源码如下：</p>
<div>
<pre class="prettyprint linenums">public interface RunnableFuture&lt;V&gt; extends Runnable, Future&lt;V&gt; {<br />
    void run();<br />
}</pre>
</div>
<p>(02) FutureTask实现了RunnableFuture接口。所以，我们也说它实现了Future接口。</p>
<h3><strong>示例和源码分析(基于JDK1.7.0_40)</strong></h3>
<p>我们先通过一个示例看看Callable和Future的基本用法，然后再分析示例的实现原理。</p>
<div>
<pre class="prettyprint linenums"> import java.util.concurrent.Callable;<br />
 import java.util.concurrent.Future;<br />
 import java.util.concurrent.Executors;<br />
 import java.util.concurrent.ExecutorService;<br />
 import java.util.concurrent.ExecutionException;

 class MyCallable implements Callable {

     @Override<br />
     public Integer call() throws Exception {<br />
         int sum    = 0;<br />
         // 执行任务<br />
         for (int i=0; i&lt;100; i++)<br />
             sum += i;<br />
         //return sum;<br />
         return Integer.valueOf(sum);<br />
     }<br />
 }

 public class CallableTest1 {

     public static void main(String[] args)<br />
         throws ExecutionException, InterruptedException{<br />
         //创建一个线程池<br />
         ExecutorService pool = Executors.newSingleThreadExecutor();<br />
         //创建有返回值的任务<br />
         Callable c1 = new MyCallable();<br />
         //执行任务并获取Future对象<br />
         Future f1 = pool.submit(c1);<br />
         // 输出结果<br />
         System.out.println(f1.get());<br />
         //关闭线程池<br />
         pool.shutdown();<br />
     }<br />
 }</pre>
</div>
<p><strong>运行结果</strong>：</p>
<div>
<pre class="prettyprint linenums">4950</pre>
</div>
<p><strong>结果说明</strong>：<br />　　在主线程main中，通过newSingleThreadExecutor()新建一个线程池。接着创建Callable对象c1，然后再通过pool.submit(c1)将c1提交到线程池中进行处理，并且将返回的结果保存到Future对象f1中。然后，我们通过f1.get()获取Callable中保存的结果；最后通过pool.shutdown()关闭线程池。</p>
<p><strong>1. submit()</strong></p>
<p>submit()在java/util/concurrent/AbstractExecutorService.java中实现，它的源码如下：</p>
<div>
<pre class="prettyprint linenums">public &lt;T&gt; Future&lt;T&gt; submit(Callable&lt;T&gt; task) {<br />
    if (task == null) throw new NullPointerException();<br />
    // 创建一个RunnableFuture对象<br />
    RunnableFuture&lt;T&gt; ftask = newTaskFor(task);<br />
    // 执行&ldquo;任务ftask&rdquo;<br />
    execute(ftask);<br />
    // 返回&ldquo;ftask&rdquo;<br />
    return ftask;<br />
}</pre>
</div>
<p>说明：submit()通过newTaskFor(task)创建了RunnableFuture对象ftask。它的源码如下：</p>
<div>
<pre class="prettyprint linenums">protected &lt;T&gt; RunnableFuture&lt;T&gt; newTaskFor(Callable&lt;T&gt; callable) {<br />
    return new FutureTask&lt;T&gt;(callable);<br />
}</pre>
</div>
<p><strong>2. FutureTask的构造函数</strong></p>
<p>FutureTask的构造函数如下：</p>
<div>
<pre class="prettyprint linenums">public FutureTask(Callable&lt;V&gt; callable) {<br />
    if (callable == null)<br />
        throw new NullPointerException();<br />
    // callable是一个Callable对象<br />
    this.callable = callable;<br />
    // state记录FutureTask的状态<br />
    this.state = NEW;       // ensure visibility of callable<br />
}</pre>
</div>
<p><strong>3. FutureTask的run()方法</strong></p>
<p>我们继续回到submit()的源码中。<br />在newTaskFor()新建一个ftask对象之后，会通过execute(ftask)执行该任务。此时ftask被当作一个Runnable对象进行执行，最终会调用到它的run()方法；ftask的run()方法在java/util/concurrent/FutureTask.java中实现，源码如下：</p>
<div>
<pre class="prettyprint linenums">public void run() {<br />
    if (state != NEW ||<br />
        !UNSAFE.compareAndSwapObject(this, runnerOffset,<br />
                                     null, Thread.currentThread()))<br />
        return;<br />
    try {<br />
        // 将callable对象赋值给c。<br />
        Callable&lt;V&gt; c = callable;<br />
        if (c != null &amp;&amp; state == NEW) {<br />
            V result;<br />
            boolean ran;<br />
            try {<br />
                // 执行Callable的call()方法，并保存结果到result中。<br />
                result = c.call();<br />
                ran = true;<br />
            } catch (Throwable ex) {<br />
                result = null;<br />
                ran = false;<br />
                setException(ex);<br />
            }<br />
            // 如果运行成功，则将result保存<br />
            if (ran)<br />
                set(result);<br />
        }<br />
    } finally {<br />
        runner = null;<br />
        // 设置&ldquo;state状态标记&rdquo;<br />
        int s = state;<br />
        if (s &gt;= INTERRUPTING)<br />
            handlePossibleCancellationInterrupt(s);<br />
    }<br />
}</pre>
</div>
<p><strong>说明</strong>：run()中会执行Callable对象的call()方法，并且最终将结果保存到result中，并通过set(result)将result保存。<br />　　 &nbsp; &nbsp;之后调用FutureTask的get()方法，返回的就是通过set(result)保存的值。</p>
<hr />
<p><strong>更多内容</strong></p>
<p>1.&nbsp;<a href="http://www.cnblogs.com/skywang12345/p/3509941.html" rel="external nofollow noreferrer">Java多线程系列--&ldquo;JUC线程池&rdquo;02之 线程池原理(一)</a></p>
<p>2.&nbsp;<a href="http://www.cnblogs.com/skywang12345/p/3509954.html" rel="external nofollow noreferrer">Java多线程系列--&ldquo;JUC线程池&rdquo;03之 线程池原理(二)</a></p>
<p>3.&nbsp;<a href="http://www.cnblogs.com/skywang12345/p/3509960.html" rel="external nofollow noreferrer">Java多线程系列--&ldquo;JUC线程池&rdquo;04之 线程池原理(三)</a></p>
<p>4.&nbsp;<a href="http://www.cnblogs.com/skywang12345/p/3512947.html" rel="external nofollow noreferrer">Java多线程系列--&ldquo;JUC线程池&rdquo;05之 线程池原理(四)</a></p>
<p>5.&nbsp;<a href="http://www.cnblogs.com/skywang12345/p/3509903.html" rel="external nofollow noreferrer">Java多线程系列--&ldquo;JUC线程池&rdquo;01之 线程池架构</a></p>
<p>6.&nbsp;<a href="http://www.cnblogs.com/skywang12345/p/java_threads_category.html" rel="external nofollow noreferrer">Java多线程系列目录(共xx篇)</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv21ly9.html">执行jar文件生成pdf报错，Unsupported URL &amp;lt&semi;file&colon;&sol;&sol;&sol;home</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ovg3eq.html">Python之路----------time模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ojzkn9.html">rotate array 旋转数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x3gz68.html">CSS3文字描边 CSS3字体外部描边</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdg4m8.html">《OD学Oozie》20160807Oozie</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mnljkq.html">IT项目技术建议书核心内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdezpp09.html">oracle 外部表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmpvee9.html">函数 buf&lowbar;block&lowbar;init</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp0gjxq.html">Codeforces Round &num;198 &lpar;Div&period; 2&rpar; B&period; Maximal Area Quadrilateral</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjnzpj8.html">RPC框架基本原理&lpar;三&rpar;：调用链路分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn0jj9.html">Postman使用教程&mdash;&mdash;调试网络接口的凶器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwko78.html">dispatch&lowbar;sync和dispatch&lowbar;async的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey603m9.html">键值编码KVC</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylkle9.html">Hadoop 实现 TF-IDF 计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljr37x9.html">3&period;Git基础-查看当前文件状态、跟踪新文件、暂存文件、忽略文件、提交更新、移除文件、移动文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjg30l8.html">SpringBoot实用小技巧之动态设置SpringBoot日志级别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvmddx8.html">Chrom Firefox 非安全端口访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wgr3q.html">htop的安装和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllw0gkq.html">node 下less无法编译的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e43v4e9.html">Flask--（一对多）模型渲染表单数据</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4953rn08.html">21、ASP&period;NET MVC入门到精通&mdash;&mdash;ASP&period;NET MVC4优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93pxon8.html">亿级规模的Elasticsearch优化实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7emxg9.html">Hibernate 参数设置一览表</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zk1yx8.html">Netty（六）UDP在netty中的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdjpw0q.html">JS高程3&period;基本概念（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jmzve9.html">【requireJS源码学习03】细究requireJS的加载流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rngjmq.html">autocomplete&equals;&amp;quot&semi;off&amp;quot&semi;  不起作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93pp0w8.html">Android Json处理框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pp77z9.html">hibernate基础dao类</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyv63xq.html">在Dell R720服务器上安装ESXI5&period;5时会出现卡在LSI&lowbar;MR3&period;V00的解决方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
